import React, { Suspense } from 'react';
import ReactDOM from 'react-dom';
import './App.css';
import { Menu, Button, Result, notification } from 'antd';
import { $Axios } from './common/publish';
import { SettingOutlined, DollarCircleOutlined, } from '@ant-design/icons';
import * as Icons from "@ant-design/icons";
import cookie from 'react-cookies'
import {
  MenuUnfoldOutlined,
  MenuFoldOutlined,
  FrownTwoTone,
  SmileTwoTone,
  MehTwoTone 
} from '@ant-design/icons';
export default class App extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      isLogin: true,
      current: 1,
      arr1: [
        { txt: '商户入网', icon: 'GlobalOutlined', assembly: 'Layout' }, //  no  1-0
        // { txt: '商户入网列表', icon: 'SlidersOutlined', assembly: 'center-tab' }   // ok 1-1
      ],
      arr2: [
        { txt: '账户概览', icon: '', assembly: 'Account-overview' },  //ok 2-0
        { txt: '订单查询', icon: '', assembly: 'Finance-orderQuery' },//ok  2-1
        { txt: '退款查询', icon: '', assembly: 'Refund-inquiry' },  //ok  2-2
        { txt: '发起提现', icon: '', assembly: 'Cash-initiated' }, //ok 2-3
        { txt: '提现记录', icon: '', assembly: 'Withdrawal-record' }, //ok 2-4
        { txt: '分账结算记录', icon: '', assembly: 'Income-record' }, //ok 2-5
      ],
      assembly: 'Layout',
      defaultSelectedKeys: 'Layout',
      assembly_cw: 'Account-overview',
      user_txt: {},
      signout: false,
      isSignout: 'no',
      yc: '',
      jurs: true,
      jur: null,
      ktyc : true
    }
  }
  // 测试  入网申请失败 250 3
  // 测试  入网申请成功 252 3
  // 测试  入网成功  com.smrongshengtianxia  2
  //初始化执行
  componentDidMount() {
    let isSignout = localStorage.getItem('isSignout');  //获取退出时存储的数据,用于判断用户退出后是否刷新页面
    // let userData = {   //默认信息
    //   userName: '用户名xxx',
    //   mallId: 2, //多商户所属商城id
    //   merchantNo: 250 , //入网申请失败',//入网的appname、社群name、商户号等(香香或者嘉旺提供) 
    //   merchantType: 3,//入网来源，2：app或社群3：商户或店铺(香香或者嘉旺提供)
    //   Jur: 1,//用户权限
    //   pages: '1-0',
    //   org_name : '商户名xxx'
    // }

    let s = "{\"userName\":\"15392502888\",\"merchantNo\":\"com.smyipaijide\",\"org_name\":\"易拍即得\",\"mallId\":\"com.smrongshengtianxia\",\"Jur\":1,\"pages\":\"1-0\",\"merchantType\":2}"

    // console.log(s)
    console.log(JSON.parse(unescape(s)))
    // let userData = cookie.load('userInformation');// 获取上游跳转时带给的信息
    // let type = this.isObject(userData)
    // if( type == false){
    // }
    let userData = JSON.parse(unescape(s));

    this.autoLogin(userData) //跳转查询用户信息,验证用户是否入网
    if (isSignout == 'yes' && userData == undefined) { //拦截是否为刷新页面
      this.setState({
        signout: true
      })
    }

    window.onbeforeunload = () => {
      // 这里写    
      localStorage.removeItem('wData');
      localStorage.removeItem('sData');
      localStorage.removeItem('oData');
      localStorage.removeItem('userData');
      localStorage.removeItem('rightArray');
      localStorage.removeItem('verification');
    }

  }


  isObject(obj) {
    return (typeof obj == 'object') && obj.constructor == Object;
  }
  initJurisdiction() {//初始化用户权限
    let e = JSON.parse(localStorage.getItem('userData'));
    let page = e.pages.split('-');  //切割拿到的跳转菜单字符串，分割跳转
    if (page[0] == 1) {
      let arr = this.state.arr1;
      this.setState({
        user_txt: e,
        current: page[0],
        assembly: arr.find((item, index) => { return index == page[1] }).assembly
      })
    } else {
      let arr = this.state.arr2;
      this.setState({
        user_txt: e,
        current: page[0],
        assembly_cw: arr.find((item, index) => { return index == page[1] }).assembly
      })
    }
  }

  handleClick(e) {  //上方导航菜单点击
    this.setState({
      current: e.key,
    });
    this.initassembly()
  }

  toggleCollapsed(e) {  //收缩左侧菜单
    this.setState({
      collapsed: !this.state.collapsed,
    });
  }

  toggleNavs(e) {  //左侧菜单点击
    let current = this.state.current;
    if (current == 1) {
      this.setState({
        assembly: e.key,
      });
    } else {
      this.setState({
        assembly_cw: e.key
      });
    }

  }

  initassembly() { //按需引入插件进行加载
    let current = this.state.current;
    let Assembly = null;
    if (current == 1) {
      Assembly = React.lazy(() => import(`./component/${this.state.assembly}/${this.state.assembly}.jsx`));
    } else {
      Assembly = React.lazy(() => import(`./component/${this.state.assembly_cw}/${this.state.assembly_cw}.jsx`));
    }
    return <Suspense fallback="" key="dialog"><Assembly refModal={this.state.current} /></Suspense>
  }

  initIcon(item) {  //用于遍历渲染左侧菜单ICON
    let Icon = item.icon;
    return React.createElement(Icons[Icon])
  }
  /**
   * 逻辑更改：如果商户已入网则不会跳转到入网页面并且隐藏入网菜单
   * 逻辑更改：如果商户未入网无论指定跳转到任何页面全部跳转为入网页面
   */
  autoLogin = (e) => {   //初始化进入页面请求查询用户是否入网以及其他信息
    localStorage.setItem('userData', JSON.stringify(e)) //存储上游信息 到本地储存
    let that_ = this;
    let url = '/payment/merchant.query.groovy'
    let param = {
      action: "queryInfo",
      merchantNo: e.merchantNo,
      merchantType: e.merchantType,
    }
    $Axios('get', url, param, (res) => {
      let status = res.data.head.status;

      if (status >= 700) { //账户状态异常 或者 未入网
        let Tips = res.data.body;
        notification.open({ //给出提示
          message: '提示:',
          description: Tips,
          icon: <MehTwoTone  twoToneColor="red" />,
          onClick: () => { },
        });
        e.pages = '1-0'  // 并予以拦截
        that_.setState({
          assembly: 'Layout',
          ktyc : false
        });
      } else if (status == 200) {  //账户状态正常
        let Flag = res.data.body.subMerchantReviewStatus;
        let Dtips = res.data.body.subMerchantReviewRemarks;
        if (Flag !== 7) { //账户入网申请失败  返回信息

          that_.FlagIsStatus(Flag,Dtips)  
          that_.setState({ // 予以拦截 不展示上方第二菜单
            ktyc : false
          });

        } else { //账户入网申请成功
          notification.open({
            message: '提示:',
            description: '该账户已入网！',
            icon: <SmileTwoTone  twoToneColor="green" />,
            onClick: () => { },
          });
          //已入网用户进行菜单拦截 不在进入 商户入网界面
          that_.setState({
            arr1: [{ txt: '商户入网列表', icon: 'SlidersOutlined', assembly: 'center-tab' }],
            assembly: 'center-tab',
            jurs: false
          });
          if (e.pages == '1-0') {
            e.pages = '2-0'
          }
        }

      }
      localStorage.setItem('userData', JSON.stringify(e)) //存储上游信息 到本地储存
      that_.initJurisdiction();  //初始化用户权限以及各种信息
    });

    return e
  }


  FlagTKtips(Tips,Dtips){
    notification.open({
      message: Tips,
      description: Dtips,
      icon: <FrownTwoTone  twoToneColor="red" />,
      onClick: () => { },
    });
  }


  FlagIsStatus(e,Dtips){
    let Tips = '';
    switch(e){
      case 1:
        Tips = '入网参数错误！'
        this.FlagTKtips(Tips,Dtips);
        this.setState({
          yc : true
        })
        break;
      case 2:
        Tips = '待审核!'
        this.FlagTKtips(Tips,Dtips);
        this.setState({
          yc : true,
          title : Tips,
          subTitle : '申请已经发起,请等待审核!'
        })
      break;
      case 3:
        Tips = '审核中!'
        this.FlagTKtips(Tips,Dtips);
        this.setState({
          yc : true,
          title : Tips,
          subTitle : '申请已经发起,已开始审核,请等待结果!'
        })
      break;
      case 4:
        Tips = '审核通过!'
        this.FlagTKtips(Tips,Dtips);
        this.setState({
          yc : true,
          title : Tips,
          subTitle : '审核已通过,正在入网入网,请等待结果!'
        })
      break;
      case 5:
        Tips = '审核不通过!'
        this.FlagTKtips(Tips,Dtips);
      break;
      case 6:
        Tips = '审核拒绝!'
        this.FlagTKtips(Tips,Dtips);
      break;
      case 7:
        Tips = '入网完成!'
        this.FlagTKtips(Tips,Dtips);
      break;
    }
    return Tips
  }


  signout() {
    localStorage.setItem('isSignout', 'yes')
    localStorage.removeItem('userData') //退出清除用户本地数据
    cookie.remove('userInformation')
    this.setState({
      signout: true
    });

  }

  render() {
    const { current, arr1, arr2, user_txt, signout, assembly, assembly_cw, yc, jurs, jur, ktyc , title,subTitle } = this.state;
    const { SubMenu } = Menu;
    return (
      <React.Fragment>
         {
          yc == true && <div style={{ width: '100%', height: '100%' }}>
            <Result
              status="success"
              title={title}
              subTitle={subTitle}
            // extra={}
            />
          </div>
        }
        {
          signout == true && <div style={{ width: '100%', height: '100%' }}>
            <Result
              status="success"
              title="您已退出登录!"
              subTitle="You have logged out."
            // extra={}
            />
          </div>
        }
        {
          signout == false && yc == '' && <div style={{ width: '100%', height: '100%' }}>
            <div className='wrap'>
              <div ></div>
              <div className='header_nav'>
                <div className='header_title'>商户入网信息管理平台</div>
                <div className='header_menu'>
                  <div className='head-sj'>
                    <Button type="primary" onClick={this.toggleCollapsed.bind(this)} style={{ marginBottom: 16 }} style={{ height: '100%' }}>
                      {React.createElement(this.state.collapsed ? MenuUnfoldOutlined : MenuFoldOutlined)}
                    </Button>
                  </div>
                  <Menu onClick={this.handleClick.bind(this)} selectedKeys={[current]} mode="horizontal" className='header_navs'>
                    {jurs == true && <Menu.Item key={1} icon={<SettingOutlined />}>
                      高级设置
                    </Menu.Item>}

                    {jur !== 2 && ktyc == true &&  <Menu.Item key={2} icon={<DollarCircleOutlined />}>
                      财务管理
                    </Menu.Item>}
                  </Menu>
                </div>
                <div className='header_user' style={{ lineHeight: '60px' }}>
                  <div style={{ width: '50%', lineHeight: '60px', float: 'left', whiteSpace: 'nowrap', textOverflow: 'ellipsis', overflow: 'hidden' }}>用户名 : {user_txt.userName}</div>
                  <div style={{ width: '50%', lineHeight: '60px', float: 'left' }}>
                    {/* <a>修改密码</a> */}
                    <a style={{ marginLeft: '10px' }} onClick={this.signout.bind(this)}>退出</a>
                  </div>
                </div>
              </div>
              <div className='main_centers'>
                {current == 1 && <Menu
                  className='main_left_nav'
                  defaultSelectedKeys={[this.state.assembly]}
                  mode="inline"
                  theme="dark"
                  key={assembly}
                  inlineCollapsed={this.state.collapsed}
                  onClick={this.toggleNavs.bind(this)}
                >
                  {current == 1 && (arr1.map((item, index) => (
                    <Menu.Item key={item.assembly} data={item.txt} icon={this.initIcon(item)}>
                      {item.txt}
                    </Menu.Item>
                  )))}
                </Menu>}
                {current == 2 && <Menu
                  className='main_left_nav'
                  defaultSelectedKeys={[this.state.assembly_cw]}
                  mode="inline"
                  theme="dark"
                  key={assembly_cw}
                  inlineCollapsed={this.state.collapsed}
                  onClick={this.toggleNavs.bind(this)}
                >
                  {current == 2 && (arr2.map((item, index) => (
                    <Menu.Item key={item.assembly} data={item.txt} icon={<DollarCircleOutlined />}>
                      {item.txt}
                    </Menu.Item>
                  )))}
                </Menu>}

                <div className='main_right_center'>
                  {
                    this.initassembly()
                  }
                </div>
              </div>
            </div>
          </div>
        }
      </React.Fragment>
    )
  }
}
ReactDOM.render(
  <App></App>,
  document.getElementById('root')
);