import React from 'react';
import { Radio, Select, Input,Form } from 'antd';
import select_data from '../../common/ssq';
import '../center-o/centerO.scss'

export default class centerO extends React.Component {
    constructor(props) {
        super(props)
        this.state = {
            selectData: select_data,
            cityOs: true,
            regionOs: true,
            citylist: [],
            regionlist: [],
            Params: this.props.arr,
            cityTxt: 1,
            regionTxt: 2,
            datas: null,
            lodings: false,
            desireAuth: '',
            offlist : select_data.offlist,
            validation_list : [],
            signedType : 'BY_SPLIT_BILL' // 默认被分帐方
        }

    }

    componentDidMount() {
        this.props.onRef(this);
        this.setState({
            desireAuth : this.state.Params.desireAuth == undefined ? 'DESIRE_VIDEO' : this.state.Params.desireAuth, // 开户意愿核实类型
        })
        this.initData();
    }

    listTypes(e){
        let data = this.state.offlist;
        let type = data.find((item,index) => { return item.value == e});
        if(type !== undefined){
            type = true
        }else{
            type = false
        }
        return type
    }

    initData() {
        if (this.props.arr) {  //初始化判断数据回填
            if (this.state.Params.businessAddressProvince !== undefined) {
                let Province = this.state.Params.businessAddressProvince;
                let city = this.state.Params.businessAddressCity;
                let region = this.state.Params.businessAddressArea;
                let data = this.state.selectData.Area;
                let cityList = data.find((item, index) => { return Province == item.provinceCode });
                let regionlist = cityList.mallCityList.find((item, index) => { return city == item.cityCode });
                this.setState({
                    cityOs: false,
                    citylist: cityList.mallCityList,
                    regionOs: false,
                    regionlist: regionlist.mallAreaList
                })
            }
            let signedType = this.state.Params.signedType;
            if(signedType == 'GENERAL_SUB_MERCHANT'){
                this.setState({
                    offlist:select_data.GENERAL_SUB_MERCHANT
                })
            }else{
                if(this.state.Params.registerRole == 'INDIVIDUAL_BUSINESS'){ //个体工商户
                    this.setState({
                        offlist:select_data.INDIVIDUAL_BUSINESS
                    })
                }else if(this.state.Params.registerRole == 'NATURAL_PERSON'){  //自然人
                    this.setState({
                        offlist:select_data.NATURAL_PERSON
                    })
                }else { //默认
                    this.setState({
                        offlist:select_data.offlist
                    })
                }
            }
            
        }
    }

    toParent = (data) => {
        this.props.parent.getParams_o(this, data)
    }

    Inputdata(e) {
        let Params = {
            signedType: this.state.Params.signedType == undefined ? 'BY_SPLIT_BILL' : this.state.Params.signedType,  //签约类型
            signedName: document.getElementById("qymc").value, //签约名称
            signedShorthand: document.getElementById("names").value, //商户简称
            registerRole: this.state.Params.registerRole == undefined ? '' : this.state.Params.registerRole, //商户签约性质
            cerType: this.state.Params.cerType == undefined ? '' : this.state.Params.cerType, //证书类型
            businessAddressProvince: this.state.Params.businessAddressProvince == undefined ? '' : this.state.Params.businessAddressProvince,//经营地省
            businessAddressCity: this.state.Params.businessAddressCity == undefined ? '' : this.state.Params.businessAddressCity, //经营地市
            businessAddressArea: this.state.Params.businessAddressArea == undefined ? '' : this.state.Params.businessAddressArea, //经营地区
            businessAddress: document.getElementById("mywb").value,  //经营详细地址
            contactName: document.getElementById("myname").value, //联系人姓名
            contactEmail: document.getElementById("mymail").value,// 联系人邮箱
            contactPhone: document.getElementById("mynums").value,// 联系人电话
            businessClassification: this.state.Params.businessClassification == undefined ? '' : this.state.Params.businessClassification, //业务分类 (签约类型为被分账方不传此参数)
            desireAuth: this.state.Params.desireAuth == undefined ? 'DESIRE_VIDEO' : this.state.Params.desireAuth, // 开户意愿核实类型
            // legalPersonName : this.state.Params.desireAuth == 'DESIRE_MOBILEINFO' ? document.getElementById("myname1").value : '',// 法人姓名
            // legalPersonIdNo : this.state.Params.desireAuth == 'DESIRE_MOBILEINFO' ? document.getElementById("myname2").value : '',// 法人身份证号
            legalPersonPhoneNo : this.state.Params.desireAuth == 'DESIRE_MOBILEINFO' ? document.getElementById("myname3").value : '',// 法人手机号
        }
        localStorage.setItem('oData', JSON.stringify(Params))
        return Params
    }

    handleChangeQy(e) {  //商户签约性质
        let registerRole = e;
        this.state.Params.registerRole = registerRole;
        if(this.state.signedType == 'GENERAL_SUB_MERCHANT'){   //入网类型为收单子户时
            this.setState({
                offlist:select_data.GENERAL_SUB_MERCHANT
            })
        }else{
            if(registerRole == 'INDIVIDUAL_BUSINESS'){ //个体工商户
                this.setState({
                    offlist:select_data.INDIVIDUAL_BUSINESS
                })
            }
    
            if(registerRole == 'NATURAL_PERSON'){  //自然人
                this.setState({
                    offlist:select_data.NATURAL_PERSON
                })
            }
    
            if(registerRole == 'offlist'){ //默认
                this.setState({
                    offlist:select_data.offlist
                })
            }
        }
        
    }

    handleChangeZs(e) {  //商户证书类型
        let cerType = e;
        this.state.Params.cerType = cerType;
    }

    province_select(e) {  //选择省
        this.state.Params.businessAddressProvince = e;
        let citylist = this.state.selectData.Area.find((item, index) => { return e == item.provinceCode });
        this.setState({
            cityOs: false,
            citylist: citylist.mallCityList,
            cityTxt: e.value,
            regionTxt: e.value,
            regionOs: true,
        });
    }

    city_select(e) {  //选择市
        this.state.Params.businessAddressCity = e;
        let citylist = this.state.citylist;
        let regionlist;
        if (citylist.length == 1) {
            regionlist = citylist[0].mallAreaList
        } else {
            regionlist = citylist.find((item, index) => { return e == item.cityCode }).mallAreaList
        }
        this.setState({
            regionOs: false,
            regionlist: regionlist,
        })
    }

    region_select(e) {  //选择区
        this.state.Params.businessAddressArea = e;
    }

    Textarea(e) {  //具体地址文本
        // console.log(e.target.value)
    }

    handleChange(e) { //业务类型
        // console.log(e)
        let businessClassification = e;
        this.state.Params.businessClassification = businessClassification;
    }

    onChangeRadio(e) { //开户意愿类型
        let desireAuth = e.target.value;
        this.state.Params.desireAuth = desireAuth;
        this.setState({
            desireAuth: desireAuth
        })

    }
    childMethod() { //暴露给父组件的方法,集合当前页面拿到的参数存入缓存
        let data = this.Inputdata();
        this.toParent(data)
    }

    verification(e) { //暴露给父组件的方法,验证当前页面必填项
        this.setState({
            validation_list : e
        })
    }

    inputDatas(e) {
        // console.log(e)
    }
    
    signedTypeRadio(e){
        let signedType = e.target.value;
        this.state.Params.signedType = signedType;
        if(signedType == 'GENERAL_SUB_MERCHANT'){
            this.setState({
                signedType: signedType,
                offlist : select_data.GENERAL_SUB_MERCHANT
            })
        }else{
            this.setState({
                signedType: signedType,
                offlist : select_data.offlist
            })
        }
       
    }


    render() {
        const { selectData, cityOs, regionOs, citylist, regionlist, cityTxt, regionTxt, desireAuth, Params , validation_list, signedType } = this.state;
        const { Option } = Select;
        const { TextArea } = Input;
        const layout = {
            labelCol: { span: 4 },
            // wrapperCol: { span:  },
          };
        return (
            <div className='center_up'>
                 <Form 
                    {...layout}
                    initialValues={{  //数据回填
                        signedType : Params.signedType == undefined ? 'BY_SPLIT_BILL' : Params.signedType,   //入网类型默认被分帐方

                    }}
                 >
                <div className='center_left'>
                    <div className='c-x' style={{height : '50px'}}>
                        <Form.Item
                            label="商户入网类型"
                            name="signedType"
                            labelCol={{ style: { width: 150 } }}
                            rules={[{ required: this.listTypes('signedType') == true ? true : false }]}
                        >
                            <Radio.Group name="signedType" onChange={this.signedTypeRadio.bind(this)}>
                                <Radio value='BY_SPLIT_BILL' >被分帐方</Radio>
                                <Radio value='GENERAL_SUB_MERCHANT' >收单子户</Radio>
                            </Radio.Group>
                        </Form.Item>
                        
                    </div>
                    <div className='c-l'>
                        <div className='inputs'>
                            <Form.Item
                                label="签约名称"
                                name="signedName"
                                labelCol={{ style: { width: 150 } }}
                                rules={[{ required: this.listTypes('signedName') == true ? true : false , message: ''}]}
                                validateStatus = {validation_list.find((item,index) => { return item == 'signedName'}) !== undefined ? 'error' : null}
                                help = {validation_list.find((item,index) => { return item == 'signedName'}) !== undefined ? '此项为必填项!' : null}
                            >
                                <Input id='qymc' style={{ width: 200 }} placeholder='请输入签约名称' defaultValue={Params.signedName} />
                            </Form.Item>
                        </div>
                    </div>
                    <div className='c-l'>
                        <Form.Item
                                label="商户签约性质"
                                name="registerRole"
                                labelCol={{ style: { width: 150 } }}
                                rules={[{ required: this.listTypes('registerRole') == true ? true : false , message: ''}]}
                                validateStatus = {validation_list.find((item,index) => { return item == 'registerRole'}) !== undefined ? 'error' : null}
                                help = {validation_list.find((item,index) => { return item == 'registerRole'}) !== undefined ? '此项为必填项!' : null}
                            >
                                 <Select
                                    size='default'
                                    id='qyxz'
                                    placeholder="请选择商户签约性质"
                                    defaultValue={Params.registerRole}
                                    onChange={this.handleChangeQy.bind(this)}
                                    style={{ width: 200 }}
                                >
                                    {selectData.contract.map((item, index) => (
                                        signedType == 'GENERAL_SUB_MERCHANT' ? 

                                            item.value !== 'ENTERPRISE_LEGAL_PERSON' ? 
                                                <Option key={index} value={item.value} disabled>{item.txt}</Option>
                                            :<Option key={index} value={item.value}>{item.txt}</Option>

                                        : <Option key={index} value={item.value}>{item.txt}</Option>
                                    ))}
                                </Select>
                            </Form.Item>
                       
                    </div>
                    <div className='c-l'>
                            <Form.Item
                                label="证书类型"
                                name="cerType"
                                labelCol={{ style: { width: 150 } }}
                                rules={[{ required: this.listTypes('cerType') == true ? true : false , message: ''}]}
                                validateStatus = {validation_list.find((item,index) => { return item == 'cerType'}) !== undefined ? 'error' : null}
                                help = {validation_list.find((item,index) => { return item == 'cerType'}) !== undefined ? '此项为必填项!' : null}
                            >
                                 <Select
                                    size='default'
                                    id='zslx'
                                    placeholder="请选择证书类型"
                                    defaultValue={Params.cerType}
                                    onChange={this.handleChangeZs.bind(this)}
                                    style={{ width: 200 }}
                                >
                                    {selectData.certificate.map((item, index) => (
                                        <Option key={index} value={item.value}>{item.txt}</Option>
                                    ))}
                                </Select>
                            </Form.Item>
                    </div>
                    <div className='c-l'>
                            <Form.Item
                                label="商户简称"
                                name="signedShorthand"
                                labelCol={{ style: { width: 150 } }}
                                rules={[{ required: this.listTypes('signedShorthand') == true ? true : false , message: ''}]}
                                validateStatus = {validation_list.find((item,index) => { return item == 'signedShorthand'}) !== undefined ? 'error' : null}
                                help = {validation_list.find((item,index) => { return item == 'signedShorthand'}) !== undefined ? '此项为必填项!' : null}
                            >
                                <Input id='names' style={{ width: 200 }} placeholder='请输入商户简称' defaultValue={Params.signedShorthand} />
                            </Form.Item>
                    </div>
                    <div className='c-l'>
                            <Form.Item
                                label="联系人姓名"
                                name="contactName"
                                labelCol={{ style: { width: 150 } }}
                                rules={[{ required: this.listTypes('contactName') == true ? true : false , message: ''}]}
                                validateStatus = {validation_list.find((item,index) => { return item == 'contactName'}) !== undefined ? 'error' : null}
                                help = {validation_list.find((item,index) => { return item == 'contactName'}) !== undefined ? '此项为必填项!' : null}
                            >
                                <Input id='myname' style={{ width: 200 }} placeholder='请输入联系人姓名' defaultValue={Params.contactName} />
                            </Form.Item>
                    </div>
                    <div className='c-l'>
                            <Form.Item
                                label="联系人邮箱"
                                name="contactEmail"
                                labelCol={{ style: { width: 150 } }}
                                rules={[{ required: this.listTypes('contactEmail') == true ? true : false , message: ''}]}
                                validateStatus = {validation_list.find((item,index) => { return item == 'contactEmail'}) !== undefined ? 'error' : null}
                                help = {validation_list.find((item,index) => { return item == 'contactEmail'}) !== undefined ? '此项为必填项!' : null}
                            >
                                <Input id='mymail' style={{ width: 200 }} placeholder='请输入联系人邮箱' defaultValue={Params.contactEmail} />
                            </Form.Item>
                    </div>
                    <div className='c-l'>
                        <Form.Item
                                label="联系人电话"
                                name="contactPhone"
                                labelCol={{ style: { width: 150 } }}
                                rules={[{ required: this.listTypes('contactPhone') == true ? true : false , message: ''}]}
                                validateStatus = {validation_list.find((item,index) => { return item == 'contactPhone'}) !== undefined ? 'error' : null}
                                help = {validation_list.find((item,index) => { return item == 'contactPhone'}) !== undefined ? '此项为必填项!' : null}
                            >
                                <Input id='mynums' style={{ width: 200 }} placeholder="请输入联系人电话" onChange={this.inputDatas.bind(this)} defaultValue={Params.contactPhone} />
                            </Form.Item>
                    </div>
                </div>
                <div className='center_right'>
                    <div className='c-l' style={{marginTop : '10px'}}>
                            <Form.Item
                                label="经营地址省"
                                name="businessAddressProvince"
                                labelCol={{ style: { width: 150 } }}
                                rules={[{ required: this.listTypes('businessAddressProvince') == true ? true : false , message: ''}]}
                                validateStatus = {validation_list.find((item,index) => { return item == 'businessAddressProvince'}) !== undefined ? 'error' : null}
                                help = {validation_list.find((item,index) => { return item == 'businessAddressProvince'}) !== undefined ? '此项为必填项!' : null}
                            >
                                 <Select size='default' placeholder="请选择省份" defaultValue={Params.businessAddressProvince} onChange={this.province_select.bind(this)} style={{ width: 200 }}>
                                    {selectData.Area.map((item, index) => (
                                        <Option key={index} value={item.provinceCode}>{item.provinceName}</Option>
                                    ))}
                                </Select>
                            </Form.Item>
                        
                    </div>
                    <div className='c-l'>
                        <Form.Item
                            label="经营地址市"
                            name="businessAddressCity"
                            labelCol={{ style: { width: 150 } }}
                            rules={[{ required: this.listTypes('businessAddressCity') == true ? true : false , message: ''}]}
                            validateStatus = {validation_list.find((item,index) => { return item == 'businessAddressCity'}) !== undefined ? 'error' : null}
                            help = {validation_list.find((item,index) => { return item == 'businessAddressCity'}) !== undefined ? '此项为必填项!' : null}
                        >
                            <Select size='default' placeholder="请选择市" defaultValue={Params.businessAddressCity} key={cityTxt} onChange={this.city_select.bind(this)} style={{ width: 200 }} disabled={cityOs}>
                                {citylist.map((item, index) => (
                                    <Option key={index} value={item.cityCode}>{item.cityName}</Option>
                                ))}
                            </Select>
                        </Form.Item>
                    </div>
                    <div className='c-l'>
                        <Form.Item
                            label="经营地址区"
                            name="businessAddressArea"
                            labelCol={{ style: { width: 150 } }}
                            rules={[{ required: this.listTypes('businessAddressArea') == true ? true : false , message: ''}]}
                            validateStatus = {validation_list.find((item,index) => { return item == 'businessAddressArea'}) !== undefined ? 'error' : null}
                            help = {validation_list.find((item,index) => { return item == 'businessAddressArea'}) !== undefined ? '此项为必填项!' : null}
                        >
                            <Select size='default' placeholder="请选择区" defaultValue={Params.businessAddressArea} key={regionTxt} onChange={this.region_select.bind(this)} style={{ width: 200 }} disabled={regionOs}>
                                {regionlist.map((item, index) => (
                                    <Option key={index} value={item.areaCode}>{item.areaName}</Option>
                                ))}
                            </Select>
                        </Form.Item>                       
                    </div>
                    <div className='c-x' style={{marginBottom : '30px'}}>
                        <Form.Item
                            label="详细地址"
                            name="businessAddress"
                            labelCol={{ style: { width: 150 } }}
                            rules={[{ required: this.listTypes('businessAddress') == true ? true : false , message: ''}]}
                            validateStatus = {validation_list.find((item,index) => { return item == 'businessAddress'}) !== undefined ? 'error' : null}
                            help = {validation_list.find((item,index) => { return item == 'businessAddress'}) !== undefined ? '此项为必填项!' : null}
                        >
                             <div className='TextAreas' >
                                <TextArea id='mywb' style={{ resize: 'none' }} defaultValue={Params.businessAddress} rows={6} />
                            </div>
                        </Form.Item>
                       
                    </div>
                    <div className='c-l'>
                        <Form.Item
                            label="业务类型"
                            name="businessClassification"
                            labelCol={{ style: { width: 150 } }}
                            rules={[{ required: this.listTypes('businessClassification') == true ? true : false , message: ''}]}
                            validateStatus = {validation_list.find((item,index) => { return item == 'businessClassification'}) !== undefined ? 'error' : null}
                            help = {validation_list.find((item,index) => { return item == 'businessClassification'}) !== undefined ? '此项为必填项!' : null}
                        >
                             <Select 
                                showSearch
                                size='default' 
                                placeholder="请选择业务类型" 
                                defaultValue={Params.businessClassification} 
                                onChange={this.handleChange.bind(this)} 
                                style={{ width: 400 }}
                                filterOption={(input, option) =>
                                    option.children.toLowerCase().indexOf(input.toLowerCase()) >= 0
                                }
                             >
                                {selectData.fication.map((item, index) => (
                                    <Option key={index} value={item.value}>{item.txt}</Option>
                                ))}
                            </Select>
                        </Form.Item>
                       
                    </div>
                    <div className='c-l'>
                        <Form.Item
                            label="开户意愿核实类型"
                            name="desireAuth"
                            labelCol={{ style: { width: 150 } }}
                            rules={[{ required: this.listTypes('desireAuth') == true ? true : false }]}
                            // validateStatus="error"
                            // help="此项为必填项!"
                        >
                             <Radio.Group name="radiogroup" defaultValue={Params.desireAuth == undefined ? 'DESIRE_VIDEO' : Params.desireAuth} onChange={this.onChangeRadio.bind(this)}>
                                <Radio value='DESIRE_VIDEO'>视频验证</Radio>
                                <Radio value='DESIRE_MOBILEINFO'>手机短信验证</Radio>
                                <Radio value='DESIRE_NONEED'>其他验证方式</Radio>
                            </Radio.Group>
                        </Form.Item>                       
                    </div>
                    {
                        desireAuth == 'DESIRE_MOBILEINFO' &&
                        <div>
                            <div className='c-l'>
                                <Form.Item
                                    label="法人手机号"
                                    name="legalPersonPhoneNo"
                                    labelCol={{ style: { width: 150 } }}
                                    rules={[{ required: this.listTypes('legalPersonPhoneNo') == true ? true : false , message: ''}]}
                                    validateStatus = {validation_list.find((item,index) => { return item == 'legalPersonPhoneNo'}) !== undefined ? 'error' : null}
                                    help = {validation_list.find((item,index) => { return item == 'legalPersonPhoneNo'}) !== undefined ? '此项为必填项!' : null}
                                >
                                    <Input id='myname3' style={{ width: 200 }} placeholder="请输入法人手机号" defaultValue={Params.legalPersonPhoneNo} />
                                </Form.Item>
                            </div>
                        </div>
                    }
                </div>
                </Form>
            </div>
        )
    }
}